﻿
Public Class Form_Suggestions

    Friend Enum SuggestionTypes
        Colors
    End Enum

    Friend SuggestionType As SuggestionTypes

    Private Sub Form_Suggestions_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Select Case SuggestionType
            Case SuggestionTypes.Colors
                Me.Text = AppTitleAndVersion("") + " - Color selector"
                ShowAllColors()
        End Select
    End Sub

    ' ======================================================================================================
    '  COLOR SELECTOR
    ' ======================================================================================================
    Private Rectangles_Xsize As Int32 = 98
    Private Rectangles_Ysize As Int32 = 17
    Private Rectangles_Separation As Int32 = 4
    Private RectanglesPerRow As Int32 = 7

    Private Sub ShowAllColors()
        ' -------------------------------------------
        Dim f As Font = New Font("Arial", 10, FontStyle.Italic Or FontStyle.Bold)
        Dim bc, fc As Color
        Dim x As Int32
        Dim y As Int32
        ' -------------------------------------------
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.BackColor = Color.Gainsboro
        Me.FormBorderStyle = Windows.Forms.FormBorderStyle.FixedDialog
        Me.ClientSize = New Size((Rectangles_Xsize + Rectangles_Separation) * RectanglesPerRow + 8, 800)
        With pbox_Suggestions
            ' -------------------------------------------
            .BorderStyle = BorderStyle.None
            .Location = New Point(6, 4)
            .Width = Me.ClientSize.Width - 10
            .Height = Me.ClientSize.Height - 8
            .Image = New Bitmap(.ClientSize.Width, .ClientSize.Height)
            Dim g As Graphics = Graphics.FromImage(.Image)
            ' -------------------------------------------
            For Each s As String In GetColorNamesAsArray()
                s = s.Trim
                If s = "" Then Continue For
                ' -------------------------------------------
                bc = ColorFromColorName(s)
                If GrayScaleLuminance(bc) < 145 Then
                    fc = Color.White
                Else
                    fc = Color.Black
                End If
                ' -------------------------------------------
                If TextRenderer.MeasureText(s, f).Width > Rectangles_Xsize Then
                    Do
                        s = s.Substring(0, s.Length - 1)
                    Loop Until TextRenderer.MeasureText(s + "...", f).Width < Rectangles_Xsize
                    s += "..."
                End If
                ' -------------------------------------------
                g.FillRectangle(New SolidBrush(bc), x, y, Rectangles_Xsize, Rectangles_Ysize)
                g.DrawString(s, f, New SolidBrush(fc), x + 4, y)
                ' -------------------------------------------
                x += Rectangles_Xsize + Rectangles_Separation
                If x + Rectangles_Xsize > .Width Then
                    x = 0
                    y += Rectangles_Ysize + Rectangles_Separation
                End If
            Next
            ' -------------------------------------------
            Me.ClientSize = New Size(Me.ClientSize.Width, y + 8)
            .Show()
        End With
    End Sub

    ' =============================================================================================
    '  STATUS BAR KEYWORDS
    ' =============================================================================================
    Private Sub pbox_Suggestions_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pbox_Suggestions.MouseDown
        If e.Button = Windows.Forms.MouseButtons.Left Then
            Dim row As Int32 = (e.Y + 2) \ (Rectangles_Ysize + Rectangles_Separation)
            Dim col As Int32 = (e.X + 2) \ (Rectangles_Xsize + Rectangles_Separation)
            Dim i As Int32 = row * RectanglesPerRow + col
            Dim ca() As String = GetColorNamesAsArray()
            If i > ca.Length - 1 Then i = ca.Length - 1
            Dim s As String = ca(i)
            If s <> "" Then
                Form1.RTB.CompleteKeyword_MouseSelected(s)
                Me.Hide()
            End If
        End If
    End Sub

End Class